<?php

/*
Http test code
*/
include( './prometheus-library/all.lib' );

AutoLoad( 'Http' );
AutoLoad( 'User' );

class Em_AppServer_Client {
   var $http;
   var $debug;

   var $objects;

   Function Em_AppServer_Client() {

      $this->http                = new Http();
      $this->transparent_client  = 1;

      $this->debug               = new Debug();
      $this->debug->prefix       = 'Em_AppServer_Client::';
      $this->debug->On();

      $this->objects = Array(
         'User'
      );

   }

  /*
  The appserver passes through all of the client browser
  information so that the appserver is tricked into thinking
  it actually sees the face customer.
  */
   Function Get( $url ) {
      return $this->http->Get(
         $url,
         Array(),
         Array()
      );
   }

   Function GetObjects( $url ) {

      $request_obj = $this->http->Get( $url );

      /*
      reset( $request_obj->headers );
      while( list( $name, $value ) = each( $request_obj->headers ) ) {
         $this->debug->Message( 'Header - ' . $name . ' - ' . $value );
      }
      */

      //$this->debug->Message( 'Content : ' . $request_obj->content );
      $content_lines = explode( "\n", $request_obj->content );

      $return_objects = Array();

      $inside_object = 0;
      $open_tag      = 0;
      $current_object = '';

      $tmp_obj = new BaseObject();

      for( $i = 0; $i < count( $content_lines ); $i++ ) {

         $content_line = $content_lines[ $i ];

         $this->debug->Message( 'Content line: ' . $content_line );
         $this->debug->Message( 'Current obj : ' . $current_object );

         /* Don't use cleaned data line - multiline support =) */
         $cleaned_line = ltrim( $content_line );
         $cleaned_line = rtrim( $cleaned_line );

         if ( $inside_object == 1 ) {
            if ( ereg( '^<.' . $current_object . '>$', $cleaned_line ) ) {
               $this->debug->Message( 'End object : ' . $current_object );
               $return_objects[] = $tmp_obj;
               $tmp_obj = new BaseObject();
               $inside_object = 0;
               $current_object = '';
            } else {
               $this->debug->Message( $current_object . ' object line : ' . $content_line );
               list( $name, $value ) = explode( ': ', $cleaned_line );
               if ( $value != '' ) {
                  $code =  '$tmp_obj->' . $name . ' = "' . $value . '";';
                  $this->debug->Message( 'code : ' . $code );
                  eval( $code );
               } else {
                  $this->debug->Message( 'no value provided : ' . $cleaned_line );
               }

            }
         }

         if ( $inside_object == 0 && $cleaned_line != '' ) {

         $this->debug->Message( 'Cleaned line: ' . $cleaned_line );

            if ( ereg( '^\<(.*)\>$', $cleaned_line, $regs ) ) {
               $this->debug->Message( 'Object name : ' . $regs[ 1 ] );
               for( $x = 0; $x < count( $this->objects ); $x++ ) {
                  if ( $this->objects[ $x ] == $regs[ 1 ] ) {
                     $this->debug->Message( 'Start object : ' . $current_object );
                     $inside_object = 1;
                     $current_object = $regs[ 1 ];
                     $code = '$tmp_obj = new ' . $current_object . '();';
                     //$code = '$tmp_obj = new BaseObject();';
                     $this->debug->Message( 'code : ' . $code );
                     eval( $code );
                  }
               }
            }

         }


      }

      return $return_objects;

   }

}

$http_client   = new Http();
$http_client->transparent_client = 1;

$em_app_client = new Em_AppServer_Client();

/*
Stupid simple passive hand through:

echo $http_client->GetRaw( 'http://127.0.0.1' );

*/

/*
Http client test...
*/
/* Head pull code */

// Raw mode...
// $head_data = $http_client->HeadRaw( 'http://127.0.0.1' );
// echo( $head_data );


$req_obj = $http_client->Head( 'http://127.0.0.1/test_object.txt' );
//$req_obj = $http_client->Head( 'http://127.0.0.1' );
//$req_obj = $http_client->Get( 'http://127.0.0.1' );


echo( 'Headers:<br>' );
echo( '<ul>' );
reset( $req_obj->headers );
while( list( $name, $value ) = each( $req_obj->headers ) ) {
   echo( '<li>' . $name . ' - ' . $value );
}
echo( '</ul>' );

echo( '<br>' );

echo( 'Cookies:<br>' );
echo( '<ul>' );
reset( $req_obj->cookies );
while( list( $name, $value ) = each( $req_obj->cookies ) ) {
   echo( '<li>' . $name . ' - ' . $value );
}
echo( '</ul>' );

echo( '<br>' );
echo( 'Content :<br>' );
echo( '<pre>' );
echo( $req_obj->content );
echo( '</pre>' );

/*
Object fetch functionality:

$objects = $em_app_client->GetObjects( 'http://127.0.0.1/test_object.txt' );

for( $i = 0; $i < count( $objects ); $i++ ) {
   $object = $objects[ $i ];

   $object->DumpVars();

   echo( '<ul>' );
   echo( '<li>User object:' );
      echo( '<ul>' );
      echo( '<li>user name : ' . $object->user_name );
      echo( '<li>password : ' . $object->password );
      echo( '<li>can login : ' . $object->login_deny );
      echo( '</ul>' );
   echo( '</ul>' );

}
*/

?>
